Loading...
Searching...
No Matches
casacore::Normal Class Reference
casa package (libcasa_casa) » BasicMath_module

Normal or Gaussian distribution. More...

`#include <Random.h>`

## Public Member Functions

| Normal (RNG *gen, Double mean=0.0, Double variance=1.0)
| Construct a random number generator for a normal distribution.
virtual | ~Normal ()
| The destructor is trivial.
virtual Double | operator() ()
| Returns a value from the normal distribution.
virtual Double | mean () const
| Functions that allow you to query and change the parameters of the normal distribution.
virtual void | mean (Double x)
virtual Double | variance () const
virtual void | variance (Double x)
virtual void | setParameters (const Vector< Double > &parms)
| These function allow you to manipulate the parameters (mean & variance) described above through the base class.
virtual Vector< Double > | parameters () const
virtual Bool | checkParameters (const Vector< Double > &parms) const
Public Member Functions inherited from casacore::Random
virtual | ~Random ()
| A virtual destructor is needed to ensure that the destructor of derived classes gets used.
RNG * | generator ()
| Functions that allow you to access and change the class that generates the random bits.
void | generator (RNG *p)

## Private Attributes

Double | itsMean
Double | itsVariance
Double | itsStdDev
Bool | itsCached
Double | itsCachedValue

## Additional Inherited Members

Public Types inherited from casacore::Random
enum | Types { BINOMIAL , DISCRETEUNIFORM , ERLANG , GEOMETRIC , HYPERGEOMETRIC , NORMAL , LOGNORMAL , NEGATIVEEXPONENTIAL , POISSON , UNIFORM , WEIBULL , UNKNOWN , NUMBER_TYPES }
| This enumerator lists all the predefined random number distributions. More...
Static Public Member Functions inherited from casacore::Random
static String | asString (Random::Types type)
| Convert the enumerator to a lower-case string.
static Random::Types | asType (const String &str)
| Convert the string to enumerator.
static Random * | construct (Random::Types type, RNG *gen)
| Convert the Random::Type enumerator to a specific object (derived from Random but upcast to a Random object).
static Vector< Double > | defaultParameters (Random::Types type)
| returns the default parameters for the specified distribution.
Protected Member Functions inherited from casacore::Random
| Random (RNG *generator)
Protected Attributes inherited from casacore::Random
RNG * | itsRNG

## Detailed Description

Normal or Gaussian distribution.

### Synopsis

The Normal class implements the normal or Gaussian distribution. The mean and variance are the parameters of the distribution. The operator() functions returns a value from this distribution

It is assumed that the supplied variance is positive and an AipsError exception is thrown if this is not true. The remaining members allow you to read and set the parameters. The LogNormal class is derived from this one.

### Example

### Thrown Exceptions

- AipsError: if bad values for the arguments are given, as specified above.

### To Do

- Nothing I hope!

Definition at line 996 of file Random.h.

## Constructor & Destructor Documentation

## Normal()

casacore::Normal::Normal | ( | RNG * | gen,
|  | Double | mean = 0.0,
|  | Double | variance = 1.0 )

Construct a random number generator for a normal distribution.

The first argument is a class that produces random bits. This pointer is NOT taken over by this class and the user is responsible for deleting it. The second and third arguments define the parameters for this distribution as described in the synopsis.

References mean(), and variance().

## ~Normal()

virtual casacore::Normal::~Normal | ( |  | ) |

virtual

The destructor is trivial.

## Member Function Documentation

## checkParameters()

virtual Bool casacore::Normal::checkParameters | ( | const Vector< Double > & | parms | ) | const

virtual

Implements casacore::Random.

Reimplemented in casacore::LogNormal.

## mean() [1/2]

Double casacore::Normal::mean | ( |  | ) | const

inline virtual

Functions that allow you to query and change the parameters of the normal distribution.

Reimplemented in casacore::LogNormal.

Definition at line 1037 of file Random.h.

References itsMean.

Referenced by Normal().

## mean() [2/2]

virtual void casacore::Normal::mean | ( | Double | x | ) |

virtual

Reimplemented in casacore::LogNormal.

## operator()()

virtual Double casacore::Normal::operator() | ( |  | ) |

virtual

Returns a value from the normal distribution.

Implements casacore::Random.

Reimplemented in casacore::LogNormal.

## parameters()

virtual Vector< Double > casacore::Normal::parameters | ( |  | ) | const

virtual

Implements casacore::Random.

Reimplemented in casacore::LogNormal.

## setParameters()

virtual void casacore::Normal::setParameters | ( | const Vector< Double > & | parms | ) |

virtual

These function allow you to manipulate the parameters (mean & variance) described above through the base class.

The Vectors must always be of length two.

Implements casacore::Random.

Reimplemented in casacore::LogNormal.

## variance() [1/2]

Double casacore::Normal::variance | ( |  | ) | const

inline virtual

Reimplemented in casacore::LogNormal.

Definition at line 1041 of file Random.h.

References itsVariance.

Referenced by Normal().

## variance() [2/2]

virtual void casacore::Normal::variance | ( | Double | x | ) |

virtual

Reimplemented in casacore::LogNormal.

## Member Data Documentation

## itsCached

Bool casacore::Normal::itsCached

private

Definition at line 1033 of file Random.h.

## itsCachedValue

Double casacore::Normal::itsCachedValue

private

Definition at line 1034 of file Random.h.

## itsMean

Double casacore::Normal::itsMean

private

Definition at line 1030 of file Random.h.

Referenced by mean().

## itsStdDev

Double casacore::Normal::itsStdDev

private

Definition at line 1032 of file Random.h.

## itsVariance

Double casacore::Normal::itsVariance

private

Definition at line 1031 of file Random.h.

Referenced by variance().

The documentation for this class was generated from the following file:

- casa/BasicMath/Random.h